/* ***********************************************************
 * This file was automatically generated on 2020-04-07.      *
 *                                                           *
 * Mathematica Bindings Version 2.1.25                       *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Drives one bipolar stepper motor with up to 38V and 2.5A per phase
	/// </summary>
	public class BrickStepper : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>.
		/// </summary>
		public static int DEVICE_IDENTIFIER = 15;

		/// <summary>
		///  The display name of this device.
		/// </summary>
		public static string DEVICE_DISPLAY_NAME = "Stepper Brick";

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_MAX_VELOCITY = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_MAX_VELOCITY = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_CURRENT_VELOCITY = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_SPEED_RAMPING = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_SPEED_RAMPING = 5;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_FULL_BRAKE = 6;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_CURRENT_POSITION = 7;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_CURRENT_POSITION = 8;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_TARGET_POSITION = 9;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_TARGET_POSITION = 10;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_STEPS = 11;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_STEPS = 12;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_REMAINING_STEPS = 13;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_STEP_MODE = 14;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_STEP_MODE = 15;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_DRIVE_FORWARD = 16;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_DRIVE_BACKWARD = 17;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_STOP = 18;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_STACK_INPUT_VOLTAGE = 19;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_EXTERNAL_INPUT_VOLTAGE = 20;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_CURRENT_CONSUMPTION = 21;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_MOTOR_CURRENT = 22;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_MOTOR_CURRENT = 23;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_ENABLE = 24;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_DISABLE = 25;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_IS_ENABLED = 26;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_DECAY = 27;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_DECAY = 28;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_MINIMUM_VOLTAGE = 29;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_MINIMUM_VOLTAGE = 30;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_SYNC_RECT = 33;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_IS_SYNC_RECT = 34;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_TIME_BASE = 35;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_TIME_BASE = 36;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_ALL_DATA = 37;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_ALL_DATA_PERIOD = 38;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_ALL_DATA_PERIOD = 39;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_SPITFP_BAUDRATE_CONFIG = 231;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_SPITFP_BAUDRATE_CONFIG = 232;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_SEND_TIMEOUT_COUNT = 233;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_SPITFP_BAUDRATE = 234;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_SPITFP_BAUDRATE = 235;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_SPITFP_ERROR_COUNT = 237;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_ENABLE_STATUS_LED = 238;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_DISABLE_STATUS_LED = 239;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_IS_STATUS_LED_ENABLED = 240;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_PROTOCOL1_BRICKLET_NAME = 241;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_CHIP_TEMPERATURE = 242;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_RESET = 243;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_WRITE_BRICKLET_PLUGIN = 246;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_READ_BRICKLET_PLUGIN = 247;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_IDENTITY = 255;

		private const int CALLBACK_UNDER_VOLTAGE = 31;

		private const int CALLBACK_POSITION_REACHED = 32;

		private const int CALLBACK_ALL_DATA = 40;

		private const int CALLBACK_NEW_STATE = 41;


		/// <summary>
		/// </summary>
		public const byte STEP_MODE_FULL_STEP = 1;

		/// <summary>
		/// </summary>
		public const byte STEP_MODE_HALF_STEP = 2;

		/// <summary>
		/// </summary>
		public const byte STEP_MODE_QUARTER_STEP = 4;

		/// <summary>
		/// </summary>
		public const byte STEP_MODE_EIGHTH_STEP = 8;

		/// <summary>
		/// </summary>
		public const byte STATE_STOP = 1;

		/// <summary>
		/// </summary>
		public const byte STATE_ACCELERATION = 2;

		/// <summary>
		/// </summary>
		public const byte STATE_RUN = 3;

		/// <summary>
		/// </summary>
		public const byte STATE_DEACCELERATION = 4;

		/// <summary>
		/// </summary>
		public const byte STATE_DIRECTION_CHANGE_TO_FORWARD = 5;

		/// <summary>
		/// </summary>
		public const byte STATE_DIRECTION_CHANGE_TO_BACKWARD = 6;

		/// <summary>
		/// </summary>
		public const byte COMMUNICATION_METHOD_NONE = 0;

		/// <summary>
		/// </summary>
		public const byte COMMUNICATION_METHOD_USB = 1;

		/// <summary>
		/// </summary>
		public const byte COMMUNICATION_METHOD_SPI_STACK = 2;

		/// <summary>
		/// </summary>
		public const byte COMMUNICATION_METHOD_CHIBI = 3;

		/// <summary>
		/// </summary>
		public const byte COMMUNICATION_METHOD_RS485 = 4;

		/// <summary>
		/// </summary>
		public const byte COMMUNICATION_METHOD_WIFI = 5;

		/// <summary>
		/// </summary>
		public const byte COMMUNICATION_METHOD_ETHERNET = 6;

		/// <summary>
		/// </summary>
		public const byte COMMUNICATION_METHOD_WIFI_V2 = 7;


		/// <summary>
		///  This callback is triggered when the input voltage drops below the value set by
		///  <see cref="Tinkerforge.BrickStepper.SetMinimumVoltage"/>. The parameter is the current voltage.
		/// </summary>
		public event UnderVoltageEventHandler UnderVoltageCallback;
		/// <summary>
		/// </summary>
		public delegate void UnderVoltageEventHandler(BrickStepper sender, int voltage);

		/// <summary>
		/// </summary>
		public event UnderVoltageEventHandler UnderVoltage // for backward compatibility
		{
			add { UnderVoltageCallback += value; }
			remove { UnderVoltageCallback -= value; }
		}

		/// <summary>
		///  This callback is triggered when a position set by <see cref="Tinkerforge.BrickStepper.SetSteps"/> or
		///  <see cref="Tinkerforge.BrickStepper.SetTargetPosition"/> is reached.
		///  
		///  <note>
		///   Since we can't get any feedback from the stepper motor, this only works if the
		///   acceleration (see <see cref="Tinkerforge.BrickStepper.SetSpeedRamping"/>) is set smaller or equal to the
		///   maximum acceleration of the motor. Otherwise the motor will lag behind the
		///   control value and the callback will be triggered too early.
		///  </note>
		/// </summary>
		public event PositionReachedEventHandler PositionReachedCallback;
		/// <summary>
		/// </summary>
		public delegate void PositionReachedEventHandler(BrickStepper sender, int position);

		/// <summary>
		/// </summary>
		public event PositionReachedEventHandler PositionReached // for backward compatibility
		{
			add { PositionReachedCallback += value; }
			remove { PositionReachedCallback -= value; }
		}

		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickStepper.SetAllDataPeriod"/>. The parameters are: the current velocity,
		///  the current position, the remaining steps, the stack voltage, the external
		///  voltage and the current consumption of the stepper motor.
		/// </summary>
		public event AllDataEventHandler AllDataCallback;
		/// <summary>
		/// </summary>
		public delegate void AllDataEventHandler(BrickStepper sender, int currentVelocity, int currentPosition, int remainingSteps, int stackVoltage, int externalVoltage, int currentConsumption);

		/// <summary>
		/// </summary>
		public event AllDataEventHandler AllData // for backward compatibility
		{
			add { AllDataCallback += value; }
			remove { AllDataCallback -= value; }
		}

		/// <summary>
		///  This callback is triggered whenever the Stepper Brick enters a new state.
		///  It returns the new state as well as the previous state.
		/// </summary>
		public event NewStateEventHandler NewStateCallback;
		/// <summary>
		/// </summary>
		public delegate void NewStateEventHandler(BrickStepper sender, byte stateNew, byte statePrevious);

		/// <summary>
		/// </summary>
		public event NewStateEventHandler NewState // for backward compatibility
		{
			add { NewStateCallback += value; }
			remove { NewStateCallback -= value; }
		}

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickStepper(string uid, IPConnection ipcon) : base(uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME)
		{
			apiVersion[0] = 2;
			apiVersion[1] = 0;
			apiVersion[2] = 4;

			callbackWrappers[CALLBACK_UNDER_VOLTAGE] = new CallbackWrapper(OnUnderVoltageCallback);
			callbackWrappers[CALLBACK_POSITION_REACHED] = new CallbackWrapper(OnPositionReachedCallback);
			callbackWrappers[CALLBACK_ALL_DATA] = new CallbackWrapper(OnAllDataCallback);
			callbackWrappers[CALLBACK_NEW_STATE] = new CallbackWrapper(OnNewStateCallback);


			responseExpected[FUNCTION_SET_MAX_VELOCITY] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_MAX_VELOCITY] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_CURRENT_VELOCITY] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_SPEED_RAMPING] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_SPEED_RAMPING] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_FULL_BRAKE] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_SET_CURRENT_POSITION] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_CURRENT_POSITION] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_TARGET_POSITION] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_TARGET_POSITION] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_STEPS] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_STEPS] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_REMAINING_STEPS] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_STEP_MODE] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_STEP_MODE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_DRIVE_FORWARD] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_DRIVE_BACKWARD] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_STOP] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_STACK_INPUT_VOLTAGE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_EXTERNAL_INPUT_VOLTAGE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_CURRENT_CONSUMPTION] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_MOTOR_CURRENT] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_MOTOR_CURRENT] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_ENABLE] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_DISABLE] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_IS_ENABLED] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_DECAY] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_DECAY] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_MINIMUM_VOLTAGE] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_MINIMUM_VOLTAGE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_SYNC_RECT] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_IS_SYNC_RECT] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_TIME_BASE] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_TIME_BASE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_ALL_DATA] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_ALL_DATA_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_ALL_DATA_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_SPITFP_BAUDRATE_CONFIG] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_SPITFP_BAUDRATE_CONFIG] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_SEND_TIMEOUT_COUNT] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_SPITFP_BAUDRATE] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_SPITFP_BAUDRATE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_SPITFP_ERROR_COUNT] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_ENABLE_STATUS_LED] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_DISABLE_STATUS_LED] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_IS_STATUS_LED_ENABLED] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_PROTOCOL1_BRICKLET_NAME] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_CHIP_TEMPERATURE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_RESET] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_WRITE_BRICKLET_PLUGIN] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_READ_BRICKLET_PLUGIN] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;

			ipcon.AddDevice(this);
		}

		/// <summary>
		///  Sets the maximum velocity of the stepper motor.
		///  This function does *not* start the motor, it merely sets the maximum
		///  velocity the stepper motor is accelerated to. To get the motor running use
		///  either <see cref="Tinkerforge.BrickStepper.SetTargetPosition"/>, <see cref="Tinkerforge.BrickStepper.SetSteps"/>, <see cref="Tinkerforge.BrickStepper.DriveForward"/> or
		///  <see cref="Tinkerforge.BrickStepper.DriveBackward"/>.
		/// </summary>
		public void SetMaxVelocity(int velocity)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(10, FUNCTION_SET_MAX_VELOCITY);
			LEConverter.To((short)velocity, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the velocity as set by <see cref="Tinkerforge.BrickStepper.SetMaxVelocity"/>.
		/// </summary>
		public int GetMaxVelocity()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_MAX_VELOCITY);

			byte[] response = SendRequest(request, 10);

			return LEConverter.UShortFrom(8, response);
		}

		/// <summary>
		///  Returns the *current* velocity of the stepper motor.
		/// </summary>
		public int GetCurrentVelocity()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_CURRENT_VELOCITY);

			byte[] response = SendRequest(request, 10);

			return LEConverter.UShortFrom(8, response);
		}

		/// <summary>
		///  Sets the acceleration and deacceleration of the stepper motor.
		///  An acceleration of 1000 means, that
		///  every second the velocity is increased by 1000 *steps/s*.
		///  
		///  For example: If the current velocity is 0 and you want to accelerate to a
		///  velocity of 8000 *steps/s* in 10 seconds, you should set an acceleration
		///  of 800 *steps/s²*.
		///  
		///  An acceleration/deacceleration of 0 means instantaneous
		///  acceleration/deacceleration (not recommended)
		/// </summary>
		public void SetSpeedRamping(int acceleration, int deacceleration)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_SPEED_RAMPING);
			LEConverter.To((short)acceleration, 8, request);
			LEConverter.To((short)deacceleration, 10, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the acceleration and deacceleration as set by
		///  <see cref="Tinkerforge.BrickStepper.SetSpeedRamping"/>.
		/// </summary>
		public void GetSpeedRamping(out int acceleration, out int deacceleration)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_SPEED_RAMPING);

			byte[] response = SendRequest(request, 12);

			acceleration = LEConverter.UShortFrom(8, response);
			deacceleration = LEConverter.UShortFrom(10, response);
		}

		/// <summary>
		///  Executes an active full brake.
		///  
		///  <note type="caution">
		///   This function is for emergency purposes,
		///   where an immediate brake is necessary. Depending on the current velocity and
		///   the strength of the motor, a full brake can be quite violent.
		///  </note>
		///  
		///  Call <see cref="Tinkerforge.BrickStepper.Stop"/> if you just want to stop the motor.
		/// </summary>
		public void FullBrake()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_FULL_BRAKE);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Sets the current steps of the internal step counter. This can be used to
		///  set the current position to 0 when some kind of starting position
		///  is reached (e.g. when a CNC machine reaches a corner).
		/// </summary>
		public void SetCurrentPosition(int position)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_CURRENT_POSITION);
			LEConverter.To((int)position, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the current position of the stepper motor in steps. On startup
		///  the position is 0. The steps are counted with all possible driving
		///  functions (<see cref="Tinkerforge.BrickStepper.SetTargetPosition"/>, <see cref="Tinkerforge.BrickStepper.SetSteps"/>, <see cref="Tinkerforge.BrickStepper.DriveForward"/> or
		///  <see cref="Tinkerforge.BrickStepper.DriveBackward"/>). It also is possible to reset the steps to 0 or
		///  set them to any other desired value with <see cref="Tinkerforge.BrickStepper.SetCurrentPosition"/>.
		/// </summary>
		public int GetCurrentPosition()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_CURRENT_POSITION);

			byte[] response = SendRequest(request, 12);

			return LEConverter.IntFrom(8, response);
		}

		/// <summary>
		///  Sets the target position of the stepper motor in steps. For example,
		///  if the current position of the motor is 500 and <see cref="Tinkerforge.BrickStepper.SetTargetPosition"/> is
		///  called with 1000, the stepper motor will drive 500 steps forward. It will
		///  use the velocity, acceleration and deacceleration as set by
		///  <see cref="Tinkerforge.BrickStepper.SetMaxVelocity"/> and <see cref="Tinkerforge.BrickStepper.SetSpeedRamping"/>.
		///  
		///  A call of <see cref="Tinkerforge.BrickStepper.SetTargetPosition"/> with the parameter *x* is equivalent to
		///  a call of <see cref="Tinkerforge.BrickStepper.SetSteps"/> with the parameter
		///  (*x* - <see cref="Tinkerforge.BrickStepper.GetCurrentPosition"/>).
		/// </summary>
		public void SetTargetPosition(int position)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_TARGET_POSITION);
			LEConverter.To((int)position, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the last target position as set by <see cref="Tinkerforge.BrickStepper.SetTargetPosition"/>.
		/// </summary>
		public int GetTargetPosition()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_TARGET_POSITION);

			byte[] response = SendRequest(request, 12);

			return LEConverter.IntFrom(8, response);
		}

		/// <summary>
		///  Sets the number of steps the stepper motor should run. Positive values
		///  will drive the motor forward and negative values backward.
		///  The velocity, acceleration and deacceleration as set by
		///  <see cref="Tinkerforge.BrickStepper.SetMaxVelocity"/> and <see cref="Tinkerforge.BrickStepper.SetSpeedRamping"/> will be used.
		/// </summary>
		public void SetSteps(int steps)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_STEPS);
			LEConverter.To((int)steps, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the last steps as set by <see cref="Tinkerforge.BrickStepper.SetSteps"/>.
		/// </summary>
		public int GetSteps()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_STEPS);

			byte[] response = SendRequest(request, 12);

			return LEConverter.IntFrom(8, response);
		}

		/// <summary>
		///  Returns the remaining steps of the last call of <see cref="Tinkerforge.BrickStepper.SetSteps"/>.
		///  For example, if <see cref="Tinkerforge.BrickStepper.SetSteps"/> is called with 2000 and
		///  <see cref="Tinkerforge.BrickStepper.GetRemainingSteps"/> is called after the motor has run for 500 steps,
		///  it will return 1500.
		/// </summary>
		public int GetRemainingSteps()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_REMAINING_STEPS);

			byte[] response = SendRequest(request, 12);

			return LEConverter.IntFrom(8, response);
		}

		/// <summary>
		///  Sets the step mode of the stepper motor. Possible values are:
		///  
		///  * Full Step = 1
		///  * Half Step = 2
		///  * Quarter Step = 4
		///  * Eighth Step = 8
		///  
		///  A higher value will increase the resolution and
		///  decrease the torque of the stepper motor.
		/// </summary>
		public void SetStepMode(byte mode)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(9, FUNCTION_SET_STEP_MODE);
			LEConverter.To((byte)mode, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the step mode as set by <see cref="Tinkerforge.BrickStepper.SetStepMode"/>.
		/// </summary>
		public byte GetStepMode()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_STEP_MODE);

			byte[] response = SendRequest(request, 9);

			return LEConverter.ByteFrom(8, response);
		}

		/// <summary>
		///  Drives the stepper motor forward until <see cref="Tinkerforge.BrickStepper.DriveBackward"/> or
		///  <see cref="Tinkerforge.BrickStepper.Stop"/> is called. The velocity, acceleration and deacceleration as
		///  set by <see cref="Tinkerforge.BrickStepper.SetMaxVelocity"/> and <see cref="Tinkerforge.BrickStepper.SetSpeedRamping"/> will be used.
		/// </summary>
		public void DriveForward()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_DRIVE_FORWARD);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Drives the stepper motor backward until <see cref="Tinkerforge.BrickStepper.DriveForward"/> or
		///  <see cref="Tinkerforge.BrickStepper.Stop"/> is triggered. The velocity, acceleration and deacceleration as
		///  set by <see cref="Tinkerforge.BrickStepper.SetMaxVelocity"/> and <see cref="Tinkerforge.BrickStepper.SetSpeedRamping"/> will be used.
		/// </summary>
		public void DriveBackward()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_DRIVE_BACKWARD);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Stops the stepper motor with the deacceleration as set by
		///  <see cref="Tinkerforge.BrickStepper.SetSpeedRamping"/>.
		/// </summary>
		public void Stop()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_STOP);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the stack input voltage. The stack input voltage is the
		///  voltage that is supplied via the stack, i.e. it is given by a
		///  Step-Down or Step-Up Power Supply.
		/// </summary>
		public int GetStackInputVoltage()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_STACK_INPUT_VOLTAGE);

			byte[] response = SendRequest(request, 10);

			return LEConverter.UShortFrom(8, response);
		}

		/// <summary>
		///  Returns the external input voltage. The external input voltage is
		///  given via the black power input connector on the Stepper Brick.
		///  
		///  If there is an external input voltage and a stack input voltage, the motor
		///  will be driven by the external input voltage. If there is only a stack
		///  voltage present, the motor will be driven by this voltage.
		///  
		///  <note type="caution">
		///   This means, if you have a high stack voltage and a low external voltage,
		///   the motor will be driven with the low external voltage. If you then remove
		///   the external connection, it will immediately be driven by the high
		///   stack voltage
		///  </note>
		/// </summary>
		public int GetExternalInputVoltage()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_EXTERNAL_INPUT_VOLTAGE);

			byte[] response = SendRequest(request, 10);

			return LEConverter.UShortFrom(8, response);
		}

		/// <summary>
		///  Returns the current consumption of the motor.
		/// </summary>
		public int GetCurrentConsumption()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_CURRENT_CONSUMPTION);

			byte[] response = SendRequest(request, 10);

			return LEConverter.UShortFrom(8, response);
		}

		/// <summary>
		///  Sets the current with which the motor will be driven.
		///  
		///  <note type="caution">
		///   Do not set this value above the specifications of your stepper motor.
		///   Otherwise it may damage your motor.
		///  </note>
		/// </summary>
		public void SetMotorCurrent(int current)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(10, FUNCTION_SET_MOTOR_CURRENT);
			LEConverter.To((short)current, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the current as set by <see cref="Tinkerforge.BrickStepper.SetMotorCurrent"/>.
		/// </summary>
		public int GetMotorCurrent()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_MOTOR_CURRENT);

			byte[] response = SendRequest(request, 10);

			return LEConverter.UShortFrom(8, response);
		}

		/// <summary>
		///  Enables the driver chip. The driver parameters can be configured (maximum velocity,
		///  acceleration, etc) before it is enabled.
		/// </summary>
		public void Enable()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_ENABLE);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Disables the driver chip. The configurations are kept (maximum velocity,
		///  acceleration, etc) but the motor is not driven until it is enabled again.
		///  
		///  <note type="caution">
		///   Disabling the driver chip while the motor is still turning can damage the
		///   driver chip. The motor should be stopped calling <see cref="Tinkerforge.BrickStepper.Stop"/> function
		///   before disabling the motor power. The <see cref="Tinkerforge.BrickStepper.Stop"/> function will **not**
		///   wait until the motor is actually stopped. You have to explicitly wait for the
		///   appropriate time after calling the <see cref="Tinkerforge.BrickStepper.Stop"/> function before calling
		///   the <see cref="Tinkerforge.BrickStepper.Disable"/> function.
		///  </note>
		/// </summary>
		public void Disable()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_DISABLE);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns *true* if the driver chip is enabled, *false* otherwise.
		/// </summary>
		public bool IsEnabled()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_IS_ENABLED);

			byte[] response = SendRequest(request, 9);

			return LEConverter.BoolFrom(8, response);
		}

		/// <summary>
		///  Sets the decay mode of the stepper motor.
		///  A value of 0 sets the fast decay mode, a value of
		///  65535 sets the slow decay mode and a value in between sets the mixed
		///  decay mode.
		///  
		///  Changing the decay mode is only possible if synchronous rectification
		///  is enabled (see <see cref="Tinkerforge.BrickStepper.SetSyncRect"/>).
		///  
		///  For a good explanation of the different decay modes see
		///  `this &lt;https://ebldc.com/?p=86/&gt;`__ blog post by Avayan.
		///  
		///  A good decay mode is unfortunately different for every motor. The best
		///  way to work out a good decay mode for your stepper motor, if you can't
		///  measure the current with an oscilloscope, is to listen to the sound of
		///  the motor. If the value is too low, you often hear a high pitched
		///  sound and if it is too high you can often hear a humming sound.
		///  
		///  Generally, fast decay mode (small value) will be noisier but also
		///  allow higher motor speeds.
		///  
		///  <note>
		///   There is unfortunately no formula to calculate a perfect decay
		///   mode for a given stepper motor. If you have problems with loud noises
		///   or the maximum motor speed is too slow, you should try to tinker with
		///   the decay value
		///  </note>
		/// </summary>
		public void SetDecay(int decay)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(10, FUNCTION_SET_DECAY);
			LEConverter.To((short)decay, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the decay mode as set by <see cref="Tinkerforge.BrickStepper.SetDecay"/>.
		/// </summary>
		public int GetDecay()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_DECAY);

			byte[] response = SendRequest(request, 10);

			return LEConverter.UShortFrom(8, response);
		}

		/// <summary>
		///  Sets the minimum voltage, below which the <see cref="Tinkerforge.BrickStepper.UnderVoltageCallback"/> callback
		///  is triggered. The minimum possible value that works with the Stepper Brick is 8V.
		///  You can use this function to detect the discharge of a battery that is used
		///  to drive the stepper motor. If you have a fixed power supply, you likely do
		///  not need this functionality.
		/// </summary>
		public void SetMinimumVoltage(int voltage)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(10, FUNCTION_SET_MINIMUM_VOLTAGE);
			LEConverter.To((short)voltage, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the minimum voltage as set by <see cref="Tinkerforge.BrickStepper.SetMinimumVoltage"/>.
		/// </summary>
		public int GetMinimumVoltage()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_MINIMUM_VOLTAGE);

			byte[] response = SendRequest(request, 10);

			return LEConverter.UShortFrom(8, response);
		}

		/// <summary>
		///  Turns synchronous rectification on or off (*true* or *false*).
		///  
		///  With synchronous rectification on, the decay can be changed
		///  (see <see cref="Tinkerforge.BrickStepper.SetDecay"/>). Without synchronous rectification fast
		///  decay is used.
		///  
		///  For an explanation of synchronous rectification see
		///  `here &lt;https://en.wikipedia.org/wiki/Active_rectification&gt;`__.
		///  
		///  <note type="caution">
		///   If you want to use high speeds (&gt; 10000 steps/s) for a large
		///   stepper motor with a large inductivity we strongly
		///   suggest that you disable synchronous rectification. Otherwise the
		///   Brick may not be able to cope with the load and overheat.
		///  </note>
		/// </summary>
		public void SetSyncRect(bool syncRect)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(9, FUNCTION_SET_SYNC_RECT);
			LEConverter.To((bool)syncRect, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns *true* if synchronous rectification is enabled, *false* otherwise.
		/// </summary>
		public bool IsSyncRect()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_IS_SYNC_RECT);

			byte[] response = SendRequest(request, 9);

			return LEConverter.BoolFrom(8, response);
		}

		/// <summary>
		///  Sets the time base of the velocity and the acceleration of the stepper brick.
		///  
		///  For example, if you want to make one step every 1.5 seconds, you can set
		///  the time base to 15 and the velocity to 10. Now the velocity is
		///  10steps/15s = 1steps/1.5s.
		/// </summary>
		public void SetTimeBase(long timeBase)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_TIME_BASE);
			LEConverter.To((int)timeBase, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the time base as set by <see cref="Tinkerforge.BrickStepper.SetTimeBase"/>.
		/// </summary>
		public long GetTimeBase()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_TIME_BASE);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Returns the following parameters: The current velocity,
		///  the current position, the remaining steps, the stack voltage, the external
		///  voltage and the current consumption of the stepper motor.
		///  
		///  There is also a callback for this function, see <see cref="Tinkerforge.BrickStepper.AllDataCallback"/> callback.
		/// </summary>
		public void GetAllData(out int currentVelocity, out int currentPosition, out int remainingSteps, out int stackVoltage, out int externalVoltage, out int currentConsumption)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_ALL_DATA);

			byte[] response = SendRequest(request, 24);

			currentVelocity = LEConverter.UShortFrom(8, response);
			currentPosition = LEConverter.IntFrom(10, response);
			remainingSteps = LEConverter.IntFrom(14, response);
			stackVoltage = LEConverter.UShortFrom(18, response);
			externalVoltage = LEConverter.UShortFrom(20, response);
			currentConsumption = LEConverter.UShortFrom(22, response);
		}

		/// <summary>
		///  Sets the period with which the <see cref="Tinkerforge.BrickStepper.AllDataCallback"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		/// </summary>
		public void SetAllDataPeriod(long period)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_ALL_DATA_PERIOD);
			LEConverter.To((int)period, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickStepper.SetAllDataPeriod"/>.
		/// </summary>
		public long GetAllDataPeriod()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_ALL_DATA_PERIOD);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  The SPITF protocol can be used with a dynamic baudrate. If the dynamic baudrate is
		///  enabled, the Brick will try to adapt the baudrate for the communication
		///  between Bricks and Bricklets according to the amount of data that is transferred.
		///  
		///  The baudrate will be increased exponentially if lots of data is sent/received and
		///  decreased linearly if little data is sent/received.
		///  
		///  This lowers the baudrate in applications where little data is transferred (e.g.
		///  a weather station) and increases the robustness. If there is lots of data to transfer
		///  (e.g. Thermal Imaging Bricklet) it automatically increases the baudrate as needed.
		///  
		///  In cases where some data has to transferred as fast as possible every few seconds
		///  (e.g. RS485 Bricklet with a high baudrate but small payload) you may want to turn
		///  the dynamic baudrate off to get the highest possible performance.
		///  
		///  The maximum value of the baudrate can be set per port with the function
		///  <see cref="Tinkerforge.BrickStepper.SetSPITFPBaudrate"/>. If the dynamic baudrate is disabled, the baudrate
		///  as set by <see cref="Tinkerforge.BrickStepper.SetSPITFPBaudrate"/> will be used statically.
		///  
		///  .. versionadded:: 2.3.6$nbsp;(Firmware)
		/// </summary>
		public void SetSPITFPBaudrateConfig(bool enableDynamicBaudrate, long minimumDynamicBaudrate)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(13, FUNCTION_SET_SPITFP_BAUDRATE_CONFIG);
			LEConverter.To((bool)enableDynamicBaudrate, 8, request);
			LEConverter.To((int)minimumDynamicBaudrate, 9, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the baudrate config, see <see cref="Tinkerforge.BrickStepper.SetSPITFPBaudrateConfig"/>.
		///  
		///  .. versionadded:: 2.3.6$nbsp;(Firmware)
		/// </summary>
		public void GetSPITFPBaudrateConfig(out bool enableDynamicBaudrate, out long minimumDynamicBaudrate)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_SPITFP_BAUDRATE_CONFIG);

			byte[] response = SendRequest(request, 13);

			enableDynamicBaudrate = LEConverter.BoolFrom(8, response);
			minimumDynamicBaudrate = LEConverter.UIntFrom(9, response);
		}

		/// <summary>
		///  Returns the timeout count for the different communication methods.
		///  
		///  The methods 0-2 are available for all Bricks, 3-7 only for Master Bricks.
		///  
		///  This function is mostly used for debugging during development, in normal operation
		///  the counters should nearly always stay at 0.
		///  
		///  .. versionadded:: 2.3.4$nbsp;(Firmware)
		/// </summary>
		public long GetSendTimeoutCount(byte communicationMethod)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(9, FUNCTION_GET_SEND_TIMEOUT_COUNT);
			LEConverter.To((byte)communicationMethod, 8, request);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Sets the baudrate for a specific Bricklet port.
		///  
		///  If you want to increase the throughput of Bricklets you can increase
		///  the baudrate. If you get a high error count because of high
		///  interference (see <see cref="Tinkerforge.BrickStepper.GetSPITFPErrorCount"/>) you can decrease the
		///  baudrate.
		///  
		///  If the dynamic baudrate feature is enabled, the baudrate set by this
		///  function corresponds to the maximum baudrate (see <see cref="Tinkerforge.BrickStepper.SetSPITFPBaudrateConfig"/>).
		///  
		///  Regulatory testing is done with the default baudrate. If CE compatibility
		///  or similar is necessary in you applications we recommend to not change
		///  the baudrate.
		///  
		///  .. versionadded:: 2.3.3$nbsp;(Firmware)
		/// </summary>
		public void SetSPITFPBaudrate(char brickletPort, long baudrate)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(13, FUNCTION_SET_SPITFP_BAUDRATE);
			LEConverter.To((char)brickletPort, 8, request);
			LEConverter.To((int)baudrate, 9, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the baudrate for a given Bricklet port, see <see cref="Tinkerforge.BrickStepper.SetSPITFPBaudrate"/>.
		///  
		///  .. versionadded:: 2.3.3$nbsp;(Firmware)
		/// </summary>
		public long GetSPITFPBaudrate(char brickletPort)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(9, FUNCTION_GET_SPITFP_BAUDRATE);
			LEConverter.To((char)brickletPort, 8, request);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Returns the error count for the communication between Brick and Bricklet.
		///  
		///  The errors are divided into
		///  
		///  * ACK checksum errors,
		///  * message checksum errors,
		///  * framing errors and
		///  * overflow errors.
		///  
		///  The errors counts are for errors that occur on the Brick side. All
		///  Bricklets have a similar function that returns the errors on the Bricklet side.
		///  
		///  .. versionadded:: 2.3.3$nbsp;(Firmware)
		/// </summary>
		public void GetSPITFPErrorCount(char brickletPort, out long errorCountACKChecksum, out long errorCountMessageChecksum, out long errorCountFrame, out long errorCountOverflow)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(9, FUNCTION_GET_SPITFP_ERROR_COUNT);
			LEConverter.To((char)brickletPort, 8, request);

			byte[] response = SendRequest(request, 24);

			errorCountACKChecksum = LEConverter.UIntFrom(8, response);
			errorCountMessageChecksum = LEConverter.UIntFrom(12, response);
			errorCountFrame = LEConverter.UIntFrom(16, response);
			errorCountOverflow = LEConverter.UIntFrom(20, response);
		}

		/// <summary>
		///  Enables the status LED.
		///  
		///  The status LED is the blue LED next to the USB connector. If enabled is is
		///  on and it flickers if data is transfered. If disabled it is always off.
		///  
		///  The default state is enabled.
		///  
		///  .. versionadded:: 2.3.1$nbsp;(Firmware)
		/// </summary>
		public void EnableStatusLED()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_ENABLE_STATUS_LED);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Disables the status LED.
		///  
		///  The status LED is the blue LED next to the USB connector. If enabled is is
		///  on and it flickers if data is transfered. If disabled it is always off.
		///  
		///  The default state is enabled.
		///  
		///  .. versionadded:: 2.3.1$nbsp;(Firmware)
		/// </summary>
		public void DisableStatusLED()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_DISABLE_STATUS_LED);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns *true* if the status LED is enabled, *false* otherwise.
		///  
		///  .. versionadded:: 2.3.1$nbsp;(Firmware)
		/// </summary>
		public bool IsStatusLEDEnabled()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_IS_STATUS_LED_ENABLED);

			byte[] response = SendRequest(request, 9);

			return LEConverter.BoolFrom(8, response);
		}

		/// <summary>
		///  Returns the firmware and protocol version and the name of the Bricklet for a
		///  given port.
		///  
		///  This functions sole purpose is to allow automatic flashing of v1.x.y Bricklet
		///  plugins.
		/// </summary>
		public void GetProtocol1BrickletName(char port, out byte protocolVersion, out byte[] firmwareVersion, out string name)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(9, FUNCTION_GET_PROTOCOL1_BRICKLET_NAME);
			LEConverter.To((char)port, 8, request);

			byte[] response = SendRequest(request, 52);

			protocolVersion = LEConverter.ByteFrom(8, response);
			firmwareVersion = LEConverter.ByteArrayFrom(9, response, 3);
			name = LEConverter.StringFrom(12, response, 40);
		}

		/// <summary>
		///  Returns the temperature as measured inside the microcontroller. The
		///  value returned is not the ambient temperature!
		///  
		///  The temperature is only proportional to the real temperature and it has an
		///  accuracy of ±15%. Practically it is only useful as an indicator for
		///  temperature changes.
		/// </summary>
		public short GetChipTemperature()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_CHIP_TEMPERATURE);

			byte[] response = SendRequest(request, 10);

			return LEConverter.ShortFrom(8, response);
		}

		/// <summary>
		///  Calling this function will reset the Brick. Calling this function
		///  on a Brick inside of a stack will reset the whole stack.
		///  
		///  After a reset you have to create new device objects,
		///  calling functions on the existing ones will result in
		///  undefined behavior!
		/// </summary>
		public void Reset()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_RESET);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Writes 32 bytes of firmware to the bricklet attached at the given port.
		///  The bytes are written to the position offset * 32.
		///  
		///  This function is used by Brick Viewer during flashing. It should not be
		///  necessary to call it in a normal user program.
		/// </summary>
		public void WriteBrickletPlugin(char port, byte offset, byte[] chunk)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(42, FUNCTION_WRITE_BRICKLET_PLUGIN);
			LEConverter.To((char)port, 8, request);
			LEConverter.To((byte)offset, 9, request);
			LEConverter.To((byte[])chunk, 10, 32, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Reads 32 bytes of firmware from the bricklet attached at the given port.
		///  The bytes are read starting at the position offset * 32.
		///  
		///  This function is used by Brick Viewer during flashing. It should not be
		///  necessary to call it in a normal user program.
		/// </summary>
		public byte[] ReadBrickletPlugin(char port, byte offset)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(10, FUNCTION_READ_BRICKLET_PLUGIN);
			LEConverter.To((char)port, 8, request);
			LEConverter.To((byte)offset, 9, request);

			byte[] response = SendRequest(request, 40);

			return LEConverter.ByteArrayFrom(8, response, 32);
		}

		/// <summary>
		///  Returns the UID, the UID where the Brick is connected to,
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position is the position in the stack from '0' (bottom) to '8' (top).
		///  
		///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
		///  |device_identifier_constant|
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_IDENTITY);

			byte[] response = SendRequest(request, 33);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnUnderVoltageCallback(byte[] response)
		{
			if (response.Length != 10)
			{
				return; // silently ignoring callback with wrong length
			}

			int voltage = LEConverter.UShortFrom(8, response);
			var handler = UnderVoltageCallback;

			if (handler != null)
			{
				handler(this, voltage);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnPositionReachedCallback(byte[] response)
		{
			if (response.Length != 12)
			{
				return; // silently ignoring callback with wrong length
			}

			int position = LEConverter.IntFrom(8, response);
			var handler = PositionReachedCallback;

			if (handler != null)
			{
				handler(this, position);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnAllDataCallback(byte[] response)
		{
			if (response.Length != 24)
			{
				return; // silently ignoring callback with wrong length
			}

			int currentVelocity = LEConverter.UShortFrom(8, response);
			int currentPosition = LEConverter.IntFrom(10, response);
			int remainingSteps = LEConverter.IntFrom(14, response);
			int stackVoltage = LEConverter.UShortFrom(18, response);
			int externalVoltage = LEConverter.UShortFrom(20, response);
			int currentConsumption = LEConverter.UShortFrom(22, response);
			var handler = AllDataCallback;

			if (handler != null)
			{
				handler(this, currentVelocity, currentPosition, remainingSteps, stackVoltage, externalVoltage, currentConsumption);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnNewStateCallback(byte[] response)
		{
			if (response.Length != 10)
			{
				return; // silently ignoring callback with wrong length
			}

			byte stateNew = LEConverter.ByteFrom(8, response);
			byte statePrevious = LEConverter.ByteFrom(9, response);
			var handler = NewStateCallback;

			if (handler != null)
			{
				handler(this, stateNew, statePrevious);
			}
		}
	}
}
