Notebook[{
 Cell[
  BoxData[{
   RowBox[{"Needs", "[", "\"\<NETLink`\>\"", "]"}],
   RowBox[{"LoadNETAssembly", "[", RowBox[{"\"\<Tinkerforge\>\"", ",", RowBox[{RowBox[{"NotebookDirectory", "[", "]"}], "<>", "\"\<../../..\>\""}]}], "]"}]
  }], "Input"
 ],
 Cell[
  BoxData[{
   RowBox[{"host", "=", "\"\<localhost\>\""}],
   RowBox[{"port", "=", "4223"}],
   RowBox[{"uid", "=", "\"\<XYZ\>\"", RowBox[{"(*", "Change XYZ to the UID of your Tilt Bricklet", "*)"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Create IPConnection and device object", "*)"}],
   RowBox[{"ipcon", "=", RowBox[{"NETNew", "[", "\"\<Tinkerforge.IPConnection\>\"", "]"}]}],
   RowBox[{"t", "=", RowBox[{"NETNew", "[", RowBox[{"\"\<Tinkerforge.BrickletTilt\>\"", ",", "uid", ",", "ipcon"}], "]"}]}],
   RowBox[{"ipcon", "@", RowBox[{"Connect", "[", RowBox[{"host", ",", "port"}], "]"}]}],
   RowBox[{"
"}],
   RowBox[{"(*", "Get current tilt state", "*)"}],
   RowBox[{"state", "=", "t", "@", RowBox[{"GetTiltState", "[", "]"}]}],
   RowBox[{"
"}],
   RowBox[{"If", "[", RowBox[{RowBox[{"state", "==", "Tinkerforge`BrickletTilt`TILTUSTATEUCLOSED"}], ",", RowBox[{"Print", "[", "\"\<Tilt State: Closed\>\"", "]"}]}], "]"}],
   RowBox[{"If", "[", RowBox[{RowBox[{"state", "==", "Tinkerforge`BrickletTilt`TILTUSTATEUOPEN"}], ",", RowBox[{"Print", "[", "\"\<Tilt State: Open\>\"", "]"}]}], "]"}],
   RowBox[{"If", "[", RowBox[{RowBox[{"state", "==", "Tinkerforge`BrickletTilt`TILTUSTATEUCLOSEDUVIBRATING"}], ",", RowBox[{"Print", "[", "\"\<Tilt State: Closed Vibrating\>\"", "]"}]}], "]"}],
   RowBox[{"
"}],
   RowBox[{"(*", "Clean up", "*)"}],
   RowBox[{"ipcon", "@", RowBox[{"Disconnect", "[", "]"}]}],
   RowBox[{"ReleaseNETObject", "[", "t", "]"}],
   RowBox[{"ReleaseNETObject", "[", "ipcon", "]"}]
  }], "Input"
 ]
}]
